#backend
DEBUG = 0
from sys import *

def listsearch(haystack,needle):
	for x in haystack:
		if x == needle:
			return 1
	return None

class gui_data:
	def __init__(self,xml_gui):
		#iface={'none':{'comment':''}}
		self.iface={}
		self.iface_bk={} #backup while in iface dialog
		#ip={'name':{'address':'','comment':''}}
		self.ip={}
		self.ip_bk={}
		#port={'name':{'begin':'','end':'','comment':''}}
		self.port={}
		self.port_bk={}
		self.wtree = xml_gui
		#targets
		self.targets = ('ACCEPT','DROP','LOG','MARK','REJECT','TOS','SNAT','DNAT','MASQUERADE','REDIRECT')
		#rules,chains
		self.tables = ('filter','nat','mangle')
		self.chains = {}
		self.chains['filter'] = ('INPUT','FORWARD','OUTPUT')
		self.chains['nat'] = ('PREROUTING','POSTROUTING','OUTPUT')
		self.chains['mangle'] = ('PREROUTING','OUTPUT')
		self.user = {}
		self.rules = {}
		#init default chains
		for x in self.tables:
			self.user[x]=[]
			self.rules[x]={}
			for y in self.chains[x]:
				if DEBUG == 1: print x,y
				self.rules[x][y]=[]
		self.current_chain = ''
		self.current_table = ''
		self.current_rulenum = ''
		self.dlg_rule_mode = 'add'
		self.fsel_mode = ''
		self.dialog_vis = 0
		if DEBUG == 1:print "firewall-class initialized"

	def new(self,xml_gui):
		self.__init__(xml_gui)

	def add_chain(self,table,chain):
		chains = self.rules[table].keys()
		if listsearch(chains,chain) != None:
			if DEBUG == 1: print 'chain exists'
			return 1 #Chain already exists
		self.rules[table][chain]=[]
		self.user[table].append(chain)
		if DEBUG == 1: print 'self.user[table]:',self.user[table]
		if DEBUG == 1: print 'add_chain:',chain,self.rules[table]

	def del_chain(self,table,chain):
		chains = self.rules[table].keys()
		if listsearch(chains,chain) == None:
			if DEBUG == 1: print "chain didn't exist"
			return None
		del self.rules[table][chain]
		if DEBUG == 1: print "deleted chain"
		return 1


	def add_rule(self,table,chain,data):
		self.rules[table][chain].append(data)
		#if DEBUG == 1: 
		print 'add_rule:',self.rules[table][chain]#[x]

	def replace_rule(self,table,chain,rule,rulenum):
		if len(self.rules[table][chain]) < rulenum:
			if DEBUG == 1: print 'Could not replace rule rulenum > number of rules'
			return None
		else:
			self.rules[table][chain][rulenum] = rule
			if DEBUG == 1: print 'Replaced rule'

	def move_rule_up(self,table,chain,rulenum):
		if rulenum != 0:
			temp = self.rules[table][chain][rulenum-1]
			self.rules[table][chain][rulenum-1]=self.rules[table][chain][rulenum]
			self.rules[table][chain][rulenum] = temp

	def move_rule_down(self,table,chain,rulenum):
		if rulenum < (len(self.rules[table][chain])-1):
			temp = self.rules[table][chain][rulenum+1]
			self.rules[table][chain][rulenum+1]=self.rules[table][chain][rulenum]
			self.rules[table][chain][rulenum] = temp

	def del_rule(self,table,chain,rulenum):
		if DEBUG == 1: print "data.py: del_rule"
		del self.rules[table][chain][rulenum]

	def get_chain(self,table,chain):
		return self.rules[table][chain]

	#
	def add_iface(self,iface_name,iface_comment=""):
		#insert REGEX to check if iface name is ok
		self.iface[iface_name]={'comment':iface_comment}
		if DEBUG == 1: print "Debug",iface_name,":", self.iface[iface_name]
	def del_iface(self,iface_name):
		del self.iface[iface_name]
		if DEBUG == 1: print "Debug",self.iface
	#
	def add_ip(self,ip_name,ip_value,ip_comment=""):
		#insert REGEX to check if ip and name is ok
		self.ip[ip_name]={'address':ip_value,'comment':ip_comment}
		if DEBUG == 1: print "Debug",ip_name,":", self.ip[ip_name]
	#
	def del_ip(self,ip_name):
		del self.ip[ip_name]
		if DEBUG == 1:
			print "Debug", self.ip
	#
	def add_port(self,port_name,port_begin,port_end,port_comment=''):
		#insert REGEX to check if port is ok
		self.port[port_name]={'begin':port_begin,'end':port_end,'comment':port_comment}
		if DEBUG == 1:
			print "Debug",port_name,":", self.port[port_name]
	#
	def del_port(self,port_name):
		del self.port[port_name]
		if DEBUG == 1:
			print "Debug", self.ip
def test_data(gd):
	gd.add_ip("LOCALHOST","127.0.0.1/32","loopback interface")
	gd.add_ip("FWHOST","192.168.0.1/24","Firewall-Host")
	gd.add_ip("LOCALNET","192.168.0.0/32","local network")
	gd.add_iface("eth0","Ethernet Device 1")
	gd.add_iface("eth1","Ethernet Device 2")
	gd.add_iface("ippp0","ISDN Card")
	gd.add_port("http",'80',None)
	gd.add_port("ftp",'21',None)
	gd.add_port("telnet",'23',None)
	gd.add_chain('filter','INPUT')
	gd.add_chain('nat','user')
	gd.add_chain('filter','user')
	gd.add_rule('filter','INPUT',{'dest_ip': {'inv': 'FALSE', 'name': 'FWHOST'}, 'limit': {'enabled': 'FALSE'}, 'dest_port': {'inv': 'FALSE', 'name': 'ftp'}, 'state': {'enabled': 'FALSE'}, 'src_ip': {'inv': 'FALSE', 'name': 'LOCALHOST'}, 'mark': {'enabled': 'FALSE'}, 'in_iface': {'inv': 'FALSE', 'name': 'eth0'}, 'syn': {'enabled': 'FALSE'}, 'prot': {'inv': 'FALSE', 'name': 'TCP'}, 'tos': {'enabled': 'FALSE'}, 'fragment': {'enabled': 'FALSE'}, 'target': 'ACCEPT', 'src_port': {'inv': 'FALSE', 'name': 'telnet'}})
        gd.add_rule('filter','INPUT',{'dest_ip': {'inv': 'FALSE', 'name': 'LOCALNET'}, 'limit': {'enabled': 'FALSE'}, 'dest_port': {'inv': 'TRUE', 'name': 'telnet'}, 'state': {'enabled': 'FALSE'}, 'src_ip': {'inv': 'FALSE', 'name': 'FWHOST'}, 'mark': {'enabled': 'FALSE'}, 'in_iface': {'inv': 'FALSE', 'name': 'eth0'}, 'prot': {'inv': 'FALSE', 'name': 'UDP'}, 'tos': {'enabled': 'FALSE'}, 'fragment': {'enabled': 'FALSE'}, 'target': 'ACCEPT', 'src_port': {'inv': 'TRUE', 'name': 'http'}})
        gd.add_rule('filter','OUTPUT',{'dest_ip': {'inv': 'FALSE', 'name': 'LOCALHOST'}, 'target': 'ACCEPT', 'prot': {'inv': 'FALSE', 'name': 'ALL'}, 'out_iface': {'inv': 'FALSE', 'name': 'ippp0'}, 'tos': {'enabled': 'FALSE'}, 'fragment': {'enabled': 'FALSE'}, 'mark': {'enabled': 'FALSE'}, 'limit': {'enabled': 'FALSE'}, 'icmp_type': {'inv': 'FALSE', 'value': 'destination-unreachable'}, 'state': {'enabled': 'FALSE'},'src_ip': {'inv': 'FALSE', 'name': 'FWHOST'}})
        gd.add_rule('filter','INPUT',{'dest_ip': {'inv': 'FALSE', 'name': '195.3.96.67/25'}, 'limit': {'enabled': 'FALSE'}, 'dest_port': {'inv': 'FALSE', 'name': '1024:65535'}, 'state': {'enabled': 'FALSE'}, 'src_ip': {'inv': 'FALSE', 'name': '192.168.0.1/24'}, 'mark': {'enabled': 'FALSE'}, 'in_iface': {'inv': 'FALSE', 'name': 'eth0'}, 'syn': {'enabled': 'FALSE'}, 'prot': {'inv': 'FALSE', 'name': 'TCP'}, 'tos': {'enabled': 'FALSE'}, 'fragment': {'enabled': 'FALSE'}, 'target': 'ACCEPT', 'src_port': {'inv': 'FALSE', 'name': '1:1023'}})