#Functions for the rule dialog
from gui_util import *
import gtk
import string

from firewall import check
import main_window
m_win = main_window
import error_dialog

DEBUG = 0

def show(gdata):
	w = gdata.wtree
	gdata.dialog_vis=1
	#-------OLD init code----------------------------------
	#add_targets(gdata)
	#add_defined_ifaces(gdata)
	#add_defined_ips(gdata)
	#add_defined_ports(gdata)
	#w.get_widget('txt_src_ip').set_text('')
	#w.get_widget('txt_dest_ip').set_text('')
	#w.get_widget('txt_src_port').set_text('')
	#w.get_widget('txt_dest_port').set_text('')
	#-------NEW init code----------------------------------
	#-------init targets
	init_combo(gdata,'cmb_target',gdata.targets)
	#-------init ips
	init_combo_add_empty(gdata,'cmb_src_ip',gdata.ip.keys())
	init_combo_add_empty(gdata,'cmb_dest_ip',gdata.ip.keys())
	#-------init ports
	init_combo_add_empty(gdata,'cmb_src_port',gdata.port.keys())
	init_combo_add_empty(gdata,'cmb_dest_port',gdata.port.keys())
	#-------init interfaces
	init_combo_add_empty(gdata,'cmb_input_iface',gdata.iface.keys())
	init_combo_add_empty(gdata,'cmb_output_iface',gdata.iface.keys())
	#-------init snat
	init_combo_add_empty(gdata,'cmb_snat_tgt_src_ip',gdata.ip.keys())
	init_combo_add_empty(gdata,'cmb_snat_tgt_port',gdata.port.keys())
	#-------init dnat
	init_combo_add_empty(gdata,'cmb_dnat_tgt_dest_ip',gdata.ip.keys())
	init_combo_add_empty(gdata,'cmb_dnat_tgt_port',gdata.port.keys())
	#-------init masquerade
	init_combo_add_empty(gdata,'cmb_masq_tgt_port',gdata.port.keys())
	#-------init redirect
	init_combo_add_empty(gdata,'cmb_redirect_tgt_port',gdata.port.keys())
	#-------------------------------------------------------
	#set default protocol
	w.get_widget('rbt_protocol_all').clicked()
        #reset invert
	w.get_widget('chk_inv_protocol').set_active(gtk.FALSE)
	w.get_widget('chk_inv_src_ip').set_active(gtk.FALSE)
	w.get_widget('chk_inv_dest_ip').set_active(gtk.FALSE)
	w.get_widget('chk_inv_input_iface').set_active(gtk.FALSE)
	w.get_widget('chk_inv_output_iface').set_active(gtk.FALSE)
	w.get_widget('chk_inv_fragment').set_active(gtk.FALSE)
	w.get_widget('chk_inv_src_port').set_active(gtk.FALSE)
	w.get_widget('chk_inv_dest_port').set_active(gtk.FALSE)
	w.get_widget('chk_inv_tcp_flags').set_active(gtk.FALSE)
	w.get_widget('chk_inv_syn').set_active(gtk.FALSE)
	w.get_widget('chk_inv_tcp_option').set_active(gtk.FALSE)
	w.get_widget('chk_inv_icmp').set_active(gtk.FALSE)
	#set default for tcp
	w.get_widget('txt_tcp_flags_mark').set_text('')
	w.get_widget('txt_tcp_flags_comp').set_text('')
	w.get_widget('chk_use_tcp_option').set_active(gtk.FALSE)
	w.get_widget('chk_use_tcp_option').toggled()
	w.get_widget('sbt_tcp_option').set_value(1)
	w.get_widget('chk_use_syn').set_active(gtk.FALSE)
	w.get_widget('chk_use_syn').toggled()
	#set default for fragment
	w.get_widget('chk_use_fragment').set_active(gtk.FALSE)
	w.get_widget('chk_use_fragment').toggled()
	#set default for limit
	w.get_widget('chk_limit_enable').set_active(gtk.FALSE)
	w.get_widget('chk_limit_enable').toggled()
	w.get_widget('sbt_limit_rate').set_value(0)
	w.get_widget('sbt_limit_burst').set_value(0)
	#set default for mark
	w.get_widget('chk_mark_enable').set_active(gtk.FALSE)
	w.get_widget('chk_mark_enable').toggled()
	w.get_widget('txt_mark_value').set_text('')
	#set default for state
	w.get_widget('chk_state_enable').set_active(gtk.FALSE)
	w.get_widget('chk_state_enable').toggled()
	#set default for tos
	w.get_widget('chk_tos_enable').set_active(gtk.FALSE)
	w.get_widget('chk_tos_enable').toggled()
	#set default for loging
	w.get_widget('chk_log_level').set_active(gtk.FALSE)
	w.get_widget('chk_log_level').toggled()
	w.get_widget('chk_log_prefix').set_active(gtk.FALSE)
	w.get_widget('chk_log_prefix').toggled()
	w.get_widget('txt_log_prefix').set_text('')
	w.get_widget('chk_log_tcp_sequence').set_active(gtk.FALSE)
	w.get_widget('chk_log_tcp_options').set_active(gtk.FALSE)
	w.get_widget('chk_log_ip_options').set_active(gtk.FALSE)
	#set default for mark_tgt
	w.get_widget('txt_mark_tgt_value').set_text('')
	#set default for target extension visibility
	disable_tgt_ext(gdata)
	#show dialog
	gtk.GtkWindow.show_all(gdata.wtree.get_widget('dlg_rule'))
	#set default notebook pages !!important only works after show_all!!
	w.get_widget('notebook_rules').set_page(0)
	w.get_widget('notebook_targets').set_page(0)

def cancel(self,gdata):
	gdata.dialog_vis=0
	gdata.dlg_rule_mode='add'
	py_dlg = gdata.wtree.get_widget('dlg_rule')
	gtk.GtkWindow.hide_all(py_dlg)

def ok(self,gdata):
	w = gdata.wtree
        rule = {} #rule data is stored here
	error=0
	error_text=[]
	#src_ip
	src_ip=w.get_widget('txt_src_ip').get_text()
	if src_ip != '':
		if w.get_widget('chk_inv_src_ip').get_active()==gtk.TRUE:
                	src_ip_inv = 'TRUE'
		else: src_ip_inv = 'FALSE'
		if check.c_ip_netmask(src_ip) == 'OK':
			rule['src_ip'] = {'name':src_ip,'inv':src_ip_inv}
		else:
			if check.c_alias(src_ip,gdata.ip.keys()) == 'OK':
				rule['src_ip'] = {'name':src_ip,'inv':src_ip_inv}
			else:
				error = error +1
				error_text.append('Source IP format invalid!')
	else:
		if DEBUG == 1: print 'no SRC IP'

	#dest_ip
	dest_ip=w.get_widget('txt_dest_ip').get_text()
	if dest_ip != '':
		if w.get_widget('chk_inv_dest_ip').get_active()==gtk.TRUE:
                	dest_ip_inv = 'TRUE'
  		else: dest_ip_inv = 'FALSE'
		if check.c_ip_netmask(dest_ip) == 'OK':
			rule['dest_ip'] = {'name':dest_ip,'inv':dest_ip_inv}
		else:
			if check.c_alias(dest_ip,gdata.ip.keys()) == 'OK':
				rule['dest_ip'] = {'name':dest_ip,'inv':dest_ip_inv}
			else:
				error = error +1
				error_text.append('Destination IP format invalid!')
	else:
		if DEBUG == 1: print 'no DEST IP'

	#fragment
	if w.get_widget('chk_use_fragment').get_active() == gtk.TRUE:
		if w.get_widget('chk_inv_fragment').get_active() == gtk.TRUE:
			rule['fragment'] ={'enabled':'TRUE','inv':'TRUE'}
		else:
			rule['fragment'] ={'enabled':'TRUE','inv':'FALSE'}
	else: 
		rule['fragment'] ={'enabled':'FALSE'}

	#limit
	if w.get_widget('chk_limit_enable').get_active() == gtk.TRUE:
		limit_rate = '%i' %w.get_widget('sbt_limit_rate').get_value()
		limit_rate_suffix = '%s' %w.get_widget('txt_limit_rate').get_text()
		limit_burst = '%i' %w.get_widget('sbt_limit_rate').get_value()
		rule['limit']={'enabled':'TRUE','rate':limit_rate,'rate_suffix':limit_rate_suffix,'burst':limit_burst}
	else:
		rule['limit']={'enabled':'FALSE'}

	#match mark
	if w.get_widget('chk_mark_enable').get_active() == gtk.TRUE:
		mark_value = w.get_widget('txt_mark_value').get_text()
		if mark_value !='':
			rule['mark']={'enabled':'TRUE','value':mark_value}
		else:
			error = error + 1
			error_text.append('No mark value specified (match mark)!')
	else:
		rule['mark']={'enabled':'FALSE'}

	#match state
	if w.get_widget('chk_state_enable').get_active() == gtk.TRUE:
		state = w.get_widget('txt_state').get_text()
		rule['state']={'enabled':'TRUE','value':state}
	else:
		rule['state']={'enabled':'FALSE'}

	#match tos
	if w.get_widget('chk_tos_enable').get_active() == gtk.TRUE:
		tos = w.get_widget('txt_tos').get_text()
		rule['tos']={'enabled':'TRUE','value':tos}
	else:
		rule['tos']={'enabled':'FALSE'}

	#protocols
	if w.get_widget('chk_inv_protocol').get_active() == gtk.TRUE:
		protocol_inv= 'TRUE'
	else:
		protocol_inv='FALSE'

	if w.get_widget('rbt_protocol_all').get_active() == gtk.TRUE:
		rule['prot']={'name':'ALL','inv':protocol_inv}
		prot = 'ALL'
	elif w.get_widget('rbt_protocol_tcp').get_active() == gtk.TRUE:
		rule['prot']={'name':'TCP','inv':protocol_inv}
		prot = 'TCP'
		#port
		src_port=w.get_widget('txt_src_port').get_text()
		if src_port != '':
			if w.get_widget('chk_inv_src_port').get_active()==gtk.TRUE:
				src_port_inv = 'TRUE'
			else: src_port_inv = 'FALSE'
			if check.c_port(src_port) == 'OK':
				rule['src_port']={'name':src_port,'inv':src_port_inv}
			else:
				if check.c_alias(src_port,gdata.port.keys()) == 'OK':
					rule['src_port']={'name':src_port,'inv':src_port_inv}
				else:
					error = error+1
					error_text.append('Source port format invalid!')
		else:
			if DEBUG == 1: print 'no SRC Port'

		dest_port=w.get_widget('txt_dest_port').get_text()
		if dest_port != '':
			if w.get_widget('chk_inv_dest_port').get_active()==gtk.TRUE:
				dest_port_inv = 'TRUE'
			else: dest_port_inv = 'FALSE'
			if check.c_port(dest_port) == 'OK':
				rule['dest_port']={'name':dest_port,'inv':dest_port_inv}
			else:
				if check.c_alias(dest_port,gdata.port.keys()) == 'OK':
					rule['dest_port']={'name':dest_port,'inv':dest_port_inv}
				else:
					error = error+1
					error_text.append('Destination port format invalid!')
		else:
			if DEBUG == 1: print 'no DEST Port'
		#tcp_options
		#--flags
		if w.get_widget('chk_inv_tcp_flags').get_active() == gtk.TRUE:
			tcp_flags_inv = 'TRUE'
		else: tcp_flags_inv = 'FALSE'
		tcp_mark = w.get_widget('txt_tcp_flags_mark').get_text()
		tcp_comp = w.get_widget('txt_tcp_flags_comp').get_text()
		if tcp_mark+tcp_comp != '':
			if tcp_mark=='':
				error = error+1
				error_text.append('TCP flags(mark) invalid!')
			elif tcp_comp=='':
				error = error+1
				error_text.append('TCP flags(comp) invalid!')
			else: rule['tcp_flags']={'mark':tcp_mark,'comp':tcp_comp,'inv':tcp_flags_inv}
                #--Syn
		if w.get_widget('chk_use_syn').get_active() == gtk.TRUE:
			if w.get_widget('chk_inv_syn').get_active() == gtk.TRUE:
				inv_syn = 'TRUE'
			else:
				inv_syn='FALSE'
			rule['syn']={'enabled':'TRUE','inv':inv_syn}
		else:
			rule['syn']={'enabled':'FALSE'}
		#--TCP option
		if w.get_widget('chk_use_tcp_option').get_active() == gtk.TRUE:
			tcp_option = '%i'%w.get_widget('sbt_tcp_option').get_value()
			print tcp_option
			if w.get_widget('chk_inv_tcp_option').get_active() == gtk.TRUE:
				tcp_option_inv='TRUE'
			else:
				tcp_option_inv='FALSE'
			rule['tcp_option']={'value':tcp_option,'inv':tcp_option_inv}

	elif w.get_widget('rbt_protocol_udp').get_active() == gtk.TRUE:
		rule['prot']={'name':'UDP','inv':protocol_inv}
		prot = 'UDP'
		#port
		src_port=w.get_widget('txt_src_port').get_text()
		if src_port != '':
			if w.get_widget('chk_inv_src_port').get_active()==gtk.TRUE:
				src_port_inv = 'TRUE'
			else: src_port_inv = 'FALSE'
			if check.c_port(src_port) == 'OK':
				rule['src_port']={'name':src_port,'inv':src_port_inv}
			else:
				if check.c_alias(src_port,gdata.port.keys()) == 'OK':
					rule['src_port']={'name':src_port,'inv':src_port_inv}
				else:
					error = error+1
					error_text.append('Source port format invalid!')
		else:
			if DEBUG == 1: print 'no SRC Port'

		dest_port=w.get_widget('txt_dest_port').get_text()
		if dest_port != '':
			if w.get_widget('chk_inv_dest_port').get_active()==gtk.TRUE:
				dest_port_inv = 'TRUE'
			else: dest_port_inv = 'FALSE'
			if check.c_port(dest_port) == 'OK':
				rule['dest_port']={'name':dest_port,'inv':dest_port_inv}
			else:
				if check.c_alias(dest_port,gdata.port.keys()) == 'OK':
					rule['dest_port']={'name':dest_port,'inv':dest_port_inv}
				else:
					error = error+1
					error_text.append('Destination port format invalid!')
		else:
			if DEBUG == 1: print 'no DEST Port'

	elif w.get_widget('rbt_protocol_icmp').get_active() == gtk.TRUE:
		rule['prot']={'name':'ICMP','inv':protocol_inv}
		prot = 'ICMP'
		icmp_type = w.get_widget('txt_icmp_type').get_text()
		if w.get_widget('chk_inv_icmp').get_active() == gtk.TRUE:
			rule['icmp_type']={'value':icmp_type,'inv':'TRUE'}
		else:
			rule['icmp_type']={'value':icmp_type,'inv':'FALSE'}

	#interfaces
	#only valid in INPUT, FORWARD, PREROUTING chains
	valid_i_iface={'INPUT':'','FORWARD':'','PREROUTING':''}
	input_iface=w.get_widget('txt_input_iface').get_text()
	if input_iface != '':
		if valid_i_iface.has_key(gdata.current_chain)!=0:
			if w.get_widget('chk_inv_input_iface').get_active() == gtk.TRUE:
				input_iface_inv = 'TRUE'
			else: input_iface_inv = 'FALSE'
			if check.c_alias(input_iface,gdata.iface.keys()) == 'OK':
				rule['in_iface']={'name':input_iface,'inv':input_iface_inv}
			else:
				error = error+1
				error_text(gdata,'Input interface invalid!')
		else:
			error = error+1
			error_text.append('Input interface is only valid in INPUT, FORWARD and PREROUTING chains!')
	else:
		if DEBUG == 1: print 'no Input Iface'

	#only valid in OUTPUT, FORWARD, POSTROUTING chains
	valid_o_iface={'OUTPUT':'','FORWARD':'','POSTROUTING':''}
	output_iface=w.get_widget('txt_output_iface').get_text()
	if output_iface != '':
		if valid_o_iface.has_key(gdata.current_chain)!=0:
			if w.get_widget('chk_inv_output_iface').get_active() == gtk.TRUE:
				output_iface_inv = 'TRUE'
			else: output_iface_inv = 'FALSE'
			if check.c_alias(output_iface,gdata.iface.keys()) == 'OK':
				rule['out_iface']={'name':output_iface,'inv':output_iface_inv}
			else:
				error = error+1
				error_text(gdata,'Output interface invalid!')
		else:
			error = error+1
			error_text.append('Output interface is only valid in OUTPUT, FORWARD and POSTROUTING chains!')
	else:
		if DEBUG == 1: print 'no Output Iface'

	#targets
	target = w.get_widget('txt_target').get_text()
	rule['target']=target
	#--log
	if target == 'LOG':
		rule['tgt_log']={}
		if w.get_widget('chk_log_level').get_active() == gtk.TRUE:
			log_level = w.get_widget('txt_log_level').get_text()
			rule['tgt_log']['level']=log_level
		if w.get_widget('chk_log_prefix').get_active() == gtk.TRUE:
			log_prefix = w.get_widget('txt_log_prefix').get_text()
			rule['tgt_log']['prefix']=log_prefix
		if w.get_widget('chk_log_tcp_sequence').get_active() == gtk.TRUE:
			log_tcp_sequence='TRUE'
		else: tcp_sequence='FALSE'
		rule['tgt_log']['tcp_sequence']=log_tcp_sequence
		if w.get_widget('chk_log_tcp_options').get_active() == gtk.TRUE:
			log_tcp_options='TRUE'
		else: log_tcp_options='FALSE'
		rule['tgt_log']['tcp_options']=log_tcp_options
		if w.get_widget('chk_log_ip_options').get_active() == gtk.TRUE:
			log_ip_options='TRUE'
		else: log_ip_options='FALSE'
		rule['tgt_log']['ip_options']=log_ip_options

	#--mark only valid in the mangle table
	elif target == 'MARK':
		if gdata.current_table=='mangle':
			mark_tgt_value = w.get_widget('txt_mark_tgt_value').get_text()
			if mark_tgt_value != '':
				rule['tgt_mark']={'value':mark_tgt_value}
			else:
				error = error+1
				error_text.append('No mark value for the mark target specified!')
		else:
			error = error+1
			error_text.append('Mark target is only valid in the mangle table!')

	#--reject only in INPUT, OUTPUT, FORWARD chains
	elif target == 'REJECT':
		valid_reject_chains = {'INPUT':'','OUTPUT':'','FORWARD':''}
		if valid_reject_chains.has_key(gdata.current_chain)!=0:
			reject_type = w.get_widget('txt_reject_tgt').get_text()
			rule['tgt_reject']={'reject_type':reject_type}
		else:
			error = error+1
			error_text.append('The reject target is only valid in the INPUT, OUTPUT and FORWARD chains!')

	#--tos only valid in mangle table
	elif target == 'TOS':
		if gdata.current_table == 'mangle':
			tos_type = w.get_widget('txt_tos_tgt').get_text()
			rule['tgt_tos']={'value':tos_type}
		else:
			error = error+1
			error_text.append('The TOS target is only valid in the mangle table!')
        #----------- THE FOLLOWING TARGETS ARE ONLY VALID WHEN TCP OR UDP PROTOCOL IS SPECIFIED
	#--snat only valid in the POSTROUTING chain of the nat table
	elif target == 'SNAT':
		if prot == 'TCP' or prot == 'UDP':
			print 'Protocol',prot
			if gdata.current_table=='nat':
				if gdata.current_chain=='POSTROUTING':
					snat_ip = w.get_widget('txt_snat_tgt_src_ip').get_text()
					if check.c_ip_netmask(snat_ip) == 'OK':
						rule['tgt_snat']={'new_src_ip':snat_ip}
					else:
						if check.c_alias(snat_ip,gdata.ip.keys()) == 'OK':
							rule['tgt_snat']={'new_src_ip':snat_ip}
						else:
							error = error+1
							error_text.append('Invalid SNAT ip!')

					snat_port = w.get_widget('txt_snat_tgt_port').get_text()
					if snat_port != '':
						if check.c_port(snat_port) == 'OK':
							rule['tgt_snat']['port_range']=snat_port
						else:
							if check.c_alias(snat_port,gdata.port.keys()) == 'OK':
								rule['tgt_snat']['port_range']=snat_port
							else:
								error = error+1
								error_text.append('Invalid SNAT port/portrange')
					else:
						if DEBUG == 1: print 'No snat port/portrange specified!'
				else:
					error = error+1
					error_text.append('The SNAT target is only valid in the POSTROUTING chain of the nat table!')
			else:
				error = error+1
				error_text.append('The SNAT target is only valid in the POSTROUTING chain of the nat table!')
		else:
			error = error+1
			error_text.append('The SNAT target is only valid when the protocol is TCP or UDP!')

	#--dnat only valid in the PREROUTING and OUTPUT chains of the nat table
	elif target == 'DNAT':
		if prot == 'TCP' or prot == 'UDP':
			if gdata.current_table=='nat':
				valid_dnat_chains={'PREROUTING':'','OUTPUT':''}
				if valid_dnat_chains.has_key(gdata.current_chain)!=0:
					dnat_ip = w.get_widget('txt_dnat_tgt_dest_ip').get_text()
					if check.c_ip_netmask(dnat_ip) == 'OK':
						rule['tgt_dnat']={'new_dest_ip':dnat_ip}
					else:
						if check.c_alias(dnat_ip,gdata.ip.keys()) == 'OK':
							rule['tgt_dnat']={'new_dest_ip':dnat_ip}
						else:
							error = error+1
							error_text.append('Invalid DNAT ip!')

					dnat_port = w.get_widget('txt_dnat_tgt_port').get_text()
					if dnat_port != '':
						if check.c_port(dnat_port) == 'OK':
							rule['tgt_dnat']['port_range']=dnat_port
						else:
							if check.c_alias(dnat_port,gdata.port.keys()) == 'OK':
								rule['tgt_dnat']['port_range']=dnat_port
							else:
								error = error+1
								error_text.append('Invalid DNAT port/portrange')
					else:
						if DEBUG == 1: print 'No dnat port/portrange specified!'
				else:
					error = error+1
					error_text.append('The DNAT target is only valid in the PREROUTING and OUTPUT chain of the nat table!')
			else:
				error = error+1
				error_text.append('The DNAT target is only valid in the PREROUTING and OUTPUT chain of the nat table!')
		else:
				error = error+1
				error_text.append('The DNAT target is only valid when the protocol is TCP or UDP!')
	#--masquerade only valid in the POSTROUTING chain of the nat table
	elif target == 'MASQUERADE':
		if prot == 'TCP' or prot == 'UDP':
			if gdata.current_table=='nat':
				if gdata.current_chain=='POSTROUTING':
					masq_port = w.get_widget('txt_masq_tgt_port').get_text()
					if check.c_port(masq_port) == 'OK':
						rule['tgt_masq']={'port_range':masq_port}
					else:
						if check.c_alias(masq_port,gdata.port.keys()) == 'OK':
							rule['tgt_masq']={'port_range':masq_port}
						else:
							error = error+1
							error_text.append('Invalid masquerading port/portrange')
				else:
					error = error+1
					error_text.append('The MASQUERADE target is only valid in the POSTROUTING chain of the nat table!')
			else:
				error = error+1
				error_text.append('The MASQUERADE target is only valid in the POSTROUTING chain of the nat table!')
		else:
			error = error+1
			error_text.append('The MASQUERADE target is only valid when the protocol is TCP or UDP!')
	#--redirect  only valid in the PREROUTING and OUTPUT chains of the nat table
	elif target == 'REDIRECT':
		if prot == 'TCP' or prot == 'UDP':
			if gdata.current_table=='nat':
				valid_redirect_chains={'PREROUTING':'','OUTPUT':''}
				if valid_redirect_chains.has_key(gdata.current_chain) !=0:
					redirect_port = w.get_widget('txt_redirect_tgt_port').get_text()
					if check.c_port(redirect_port) == 'OK':
						rule['tgt_redirect']={'port_range':redirect_port}
					else:
						if check.c_alias(redirect_port,gdata.port.keys()) == 'OK':
							rule['tgt_redirect']={'port_range':redirect_port}
						else:
							error = error+1
							error_text.append('Invalid redirect port/portrange')
		else:
			error = error+1
			error_text.append('Redirect target is only valid when the protocol is TCP or UDP')
	if DEBUG == 1: print 'This rule:',rule

        #print mydata
	if error == 0:
		if gdata.dlg_rule_mode == 'add':
			gdata.add_rule(gdata.current_table,gdata.current_chain,rule)
		elif gdata.dlg_rule_mode == 'edit':
			gdata.replace_rule(gdata.current_table,gdata.current_chain,rule,gdata.current_rulenum)
		m_win.txt_chain1_changed(None,gdata)
		m_win.txt_chain2_changed(None,gdata)
		gdata.dialog_vis=0
		gdata.dlg_rule_mode = 'add'
		py_dlg = w.get_widget('dlg_rule')
		gtk.GtkWindow.hide_all(py_dlg)
	else:
		if DEBUG == 1: print 'Errors:',error_text
		error_dialog.show(gdata,error_text)
#----visibility for target extensions------------------------------------------
def txt_target_changed(self,gdata):
	act_tgt = gdata.wtree.get_widget('txt_target').get_text()
	if DEBUG == 1: print "txt_target_changed new target:",act_tgt
	try:
		disable_tgt_ext(gdata)
		ext_targets={
			'LOG':'tgt_log',
			'MARK':'tgt_mark',
			'REJECT':'tgt_reject',
			'TOS':'tgt_tos',
			'SNAT':'tgt_snat',
			'DNAT':'tgt_dnat',
			'MASQUERADE':'tgt_masquerade',
			'REDIRECT':'tgt_redirect'}
		#print "is ext_tgt? ",ext_targets[act_tgt]
		activate_tgt_ext(gdata,ext_targets[act_tgt])
	except:
		if DEBUG == 1: print "exception: txt_target_changed"
#----visibility for protocol settings------------------------------------------
def rbt_protocol_all_clicked(self,gdata):
	if DEBUG > 1: print "rbt_protocol_all_clicked"
	option_disable(gdata,'frm_port')
	option_disable(gdata,'frm_tcp')
	option_disable(gdata,'frm_icmp')
def rbt_protocol_tcp_clicked(self,gdata):
	if DEBUG > 1: print "rbt_protocol_tcp_clicked"
	option_enable(gdata,'frm_port')
	option_enable(gdata,'frm_tcp')
	option_disable(gdata,'frm_icmp')
def rbt_protocol_udp_clicked(self,gdata):
	if DEBUG > 1: print "rbt_protocol_udp_clicked"
	option_enable(gdata,'frm_port')
	option_disable(gdata,'frm_tcp')
	option_disable(gdata,'frm_icmp')
def rbt_protocol_icmp_clicked(self,gdata):
	if DEBUG > 1: print "rbt_protocol_icmp_clicked"
	option_disable(gdata,'frm_port')
	option_disable(gdata,'frm_tcp')
	option_enable(gdata,'frm_icmp')
#----visibility for SYN--------------------------------------------------------
def chk_use_syn_toggled(self,gdata):
	if DEBUG > 0: print 'chk_use_syn_toggle'
	if gdata.wtree.get_widget('chk_use_syn').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('chk_inv_syn').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('chk_inv_syn').set_sensitive(gtk.FALSE)
#----visibility for TCP option-------------------------------------------------
def chk_use_tcp_option_toggled(self,gdata):
	if DEBUG > 0: print 'chk_use_tcp_option_toggle'
	if gdata.wtree.get_widget('chk_use_tcp_option').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('chk_inv_tcp_option').set_sensitive(gtk.TRUE)
		gdata.wtree.get_widget('sbt_tcp_option').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('chk_inv_tcp_option').set_sensitive(gtk.FALSE)
		gdata.wtree.get_widget('sbt_tcp_option').set_sensitive(gtk.FALSE)
#----visibility for fragment---------------------------------------------------
def chk_use_fragment_toggled(self,gdata):
	if DEBUG > 0: print 'chk_use_fragment_toggle'
	#if self._o.get_active() == gtk.TRUE:
	#	gdata.wtree.get_widget('chk_inv_fragment').set_sensitive(gtk.FALSE)
	#else:
	#	gdata.wtree.get_widget('chk_inv_fragment').set_sensitive(gtk.TRUE)
	if gdata.wtree.get_widget('chk_use_fragment').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('chk_inv_fragment').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('chk_inv_fragment').set_sensitive(gtk.FALSE)
def chk_log_prefix_toggled(self,gdata):
	if DEBUG > 0: print 'chk_log_enable_toggle'
	if gdata.wtree.get_widget('chk_log_prefix').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('txt_log_prefix').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('txt_log_prefix').set_sensitive(gtk.FALSE)
def chk_log_level_toggled(self,gdata):
	if DEBUG > 0: print 'chk_log_level_toggle'
	if gdata.wtree.get_widget('chk_log_level').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('cmb_log_level').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('cmb_log_level').set_sensitive(gtk.FALSE)
#visibility for match limit
def chk_limit_enable_toggled(self,gdata):
	if DEBUG > 0: print 'chk_limit_enable_toggle'
	if gdata.wtree.get_widget('chk_limit_enable').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('frm_limit_settings').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('frm_limit_settings').set_sensitive(gtk.FALSE)
#visibility for match mark
def chk_mark_enable_toggled(self,gdata):
	if DEBUG > 0: print 'chk_mark_enable_toggle'
	if gdata.wtree.get_widget('chk_mark_enable').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('txt_mark_value').set_sensitive(gtk.TRUE)
		gdata.wtree.get_widget('lbl_mark').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('txt_mark_value').set_sensitive(gtk.FALSE)
		gdata.wtree.get_widget('lbl_mark').set_sensitive(gtk.FALSE)
#visibility for match state
def chk_state_enable_toggled(self,gdata):
	if DEBUG > 0: print 'chk_state_enable_toggle'
	if gdata.wtree.get_widget('chk_state_enable').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('cmb_state').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('cmb_state').set_sensitive(gtk.FALSE)
#visibility for match tos
def chk_tos_enable_toggled(self,gdata):
	if DEBUG > 0: print 'chk_tos_enable_toggle'
	if gdata.wtree.get_widget('chk_tos_enable').get_active() == gtk.TRUE:
		gdata.wtree.get_widget('cmb_tos').set_sensitive(gtk.TRUE)
	else:
		gdata.wtree.get_widget('cmb_tos').set_sensitive(gtk.FALSE)