#Functions for the rule dialog
from gui_util import *
import add_rule_dialog
import gtk
import string

from firewall import check
import main_window
m_win = main_window

def conv_tf(data): #Converts the Strings 'TRUE','FALSE' to gtk.TRUE, gtk.FALSE
	if data == 'TRUE': return gtk.TRUE
	elif data == 'FALSE': return gtk.FALSE
	else: print 'INVALID DATA: conv_tf()'

def show(gdata,rule,table,chain): #init of edit_rule_dialog
	add_rule_dialog.show(gdata)
	w = gdata.wtree.get_widget
	#protocol
	protocol = {'ALL':'rbt_protocol_all','TCP':'rbt_protocol_tcp','UDP':'rbt_protocol_udp','ICMP':'rbt_protocol_icmp'}
	prot = rule['prot']['name']
	w(protocol[prot]).clicked()
	w('chk_inv_protocol').set_active(conv_tf(rule['prot']['inv']))
	#target
	w('txt_target').set_text(rule['target'])
	#src IP
	if rule.has_key('src_ip')!=0:
		w('txt_src_ip').set_text(rule['src_ip']['name'])
		w('chk_inv_src_ip').set_active(conv_tf(rule['src_ip']['inv']))
	#dest IP
	if rule.has_key('dest_ip')!=0:
		w('txt_dest_ip').set_text(rule['dest_ip']['name'])
		w('chk_inv_dest_ip').set_active(conv_tf(rule['dest_ip']['inv']))
	#input iface
	if rule.has_key('in_iface')!=0:
		w('txt_input_iface').set_text(rule['in_iface']['name'])
		w('chk_inv_input_iface').set_active(conv_tf(rule['in_iface']['inv']))
	#output iface
	if rule.has_key('out_iface')!=0:
		w('txt_output_iface').set_text(rule['out_iface']['name'])
		w('chk_inv_output_iface').set_active(conv_tf(rule['out_iface']['inv']))
	#src_port
	if rule.has_key('src_port')!=0:
		w('txt_src_port').set_text(rule['src_port']['name'])
		w('chk_inv_src_port').set_active(conv_tf(rule['src_port']['inv']))
	#dest_port
	if rule.has_key('dest_port')!=0:
		w('txt_dest_port').set_text(rule['dest_port']['name'])
		w('chk_inv_dest_port').set_active(conv_tf(rule['dest_port']['inv']))
	#fragment
	if rule['fragment']['enabled']=='TRUE':
		w('chk_use_fragment').set_active(conv_tf(rule['fragment']['enabled']))
		w('chk_inv_fragment').set_active(conv_tf(rule['fragment']['inv']))
	#TCP flags
	if rule.has_key('tcp_flags')!=0:
		w('txt_tcp_flags_mark').set_text(rule['tcp_flags']['mark'])
		w('txt_tcp_flags_comp').set_text(rule['tcp_flags']['comp'])
		w('chk_inv_tcp_flags').set_active(conv_tf(rule['tcp_flags']['inv']))
	#syn
	if rule.has_key('syn')!=0:
		if rule['syn']['enabled']=='TRUE':
			w('chk_use_syn').set_active(conv_tf(rule['syn']['enabled']))
			w('chk_inv_syn').set_active(conv_tf(rule['syn']['inv']))
	#TCP option
	if rule.has_key('tcp_option')!=0:
		w('sbt_tcp_option').set_value(string.atoi(rule['tcp_option']['value']))
		w('chk_inv_tcp_option').set_active(conv_tf(rule['tcp_option']['inv']))
		w('chk_use_tcp_option').set_active(gtk.TRUE)
	#ICMP options
	if rule.has_key('icmp_type')!=0:
		w('txt_icmp_type').set_text(rule['icmp_type']['value'])
		w('chk_inv_icmp').set_active(conv_tf(rule['icmp_type']['inv']))
	#limit
	if rule['limit']['enabled']=='TRUE':
		w('chk_limit_enable').set_active(conv_tf(rule['limit']['enabled']))
		w('sbt_limit_rate').set_value(string.atoi(rule['limit']['rate']))
		w('txt_limit_rate').set_text(rule['limit']['rate_suffix'])
		w('sbt_limit_burst').set_value(string.atoi(rule['limit']['burst']))
	#mark
	if rule['mark']['enabled']=='TRUE':
		w('chk_mark_enable').set_active(conv_tf(rule['mark']['enabled']))
		w('txt_mark_value').set_text(rule['mark']['value'])
	#state
	if rule['state']['enabled']=='TRUE':
		w('chk_state_enable').set_active(conv_tf(rule['state']['enabled']))
		w('txt_state').set_text(rule['state']['value'])
	#TOS
	if rule['tos']['enabled']=='TRUE':
		w('chk_tos_enable').set_active(conv_tf(rule['tos']['enabled']))
		w('txt_tos').set_text(rule['tos']['value'])
	#log target
	if rule.has_key('tgt_log')!=0:
		if rule['tgt_log'].has_key('level')!=0:
			w('txt_log_level').set_text(rule['tgt_log']['level'])
			w('chk_log_level').set_active(gtk.TRUE)
		if rule['tgt_log'].has_key('prefix')!=0:
			w('txt_log_prefix').set_text(rule['tgt_log']['prefix'])
			w('chk_log_prefix').set_active(gtk.TRUE)
		w('chk_log_tcp_sequence').set_active(conv_tf(rule['tgt_log']['tcp_sequence']))
		w('chk_log_tcp_options').set_active(conv_tf(rule['tgt_log']['tcp_options']))
		w('chk_log_ip_options').set_active(conv_tf(rule['tgt_log']['ip_options']))
	#mark target
	if rule.has_key('tgt_mark')!=0:
		w('txt_mark_tgt_value').set_text(rule['tgt_mark']['value'])
	#reject target
	if rule.has_key('tgt_reject')!=0:
		w('txt_reject_tgt').set_text(rule['tgt_reject']['reject_type'])
	#TOS target
	if rule.has_key('tgt_tos')!=0:
		w('txt_tos_tgt').set_text(rule['tgt_tos']['value'])
	#SNAT target
	if rule.has_key('tgt_snat')!=0:
		w('txt_snat_tgt_src_ip').set_text(rule['tgt_snat']['new_src_ip'])
		if rule['tgt_snat'].has_key('port_range')!=0:
			w('txt_snat_tgt_port').set_text(rule['tgt_snat']['port_range'])
	#DNAT target
	if rule.has_key('tgt_dnat')!=0:
		w('txt_dnat_tgt_dest_ip').set_text(rule['tgt_dnat']['new_dest_ip'])
		if rule['tgt_dnat'].has_key('port_range')!=0:
			w('txt_dnat_tgt_port').set_text(rule['tgt_dnat']['port_range'])
	#masquerade target
	if rule.has_key('tgt_masq')!=0:
		w('txt_masq_tgt_port').set_text(rule['tgt_masq']['port_range'])
	#redirect target
	if rule.has_key('tgt_redirect')!=0:
		w('txt_redirect_tgt_port').set_text(rule['tgt_redirect']['port_range'])
