import gtk
import add_rule_dialog
import edit_rule_dialog
import add_iface_dialog
import add_port_dialog
import add_ip_dialog
#import file_selection_dialog
import string
from gui_util import *

DEBUG = 0

def get_rule_text(rule,key): #this function does not work with all rule properties !!
	if rule.has_key(key):
		if rule[key]['inv']=='TRUE': text='! '
		else: text=''
		return text+rule[key]['name']
	else: return ''

def show_rules(gdata,c,table,chain):
	rules = gdata.get_chain(table,chain)

        x=0
	for a in ('No.','Prot.','Source IP','Destination IP','Src. Port','Dest. Port','Target',''):
		c.set_column_title(x,a)
		x = x+1
	x=0
	for i in rules:
		protocol= get_rule_text(i,'prot')
		target=i['target']
		src_ip = get_rule_text(i,'src_ip')
		if src_ip == '':
			src_ip = 'Anywhere'
		dest_ip = get_rule_text(i,'dest_ip')
		if dest_ip == '':
			dest_ip = 'Anywhere'
		src_port = get_rule_text(i,'src_port')
		dest_port = get_rule_text(i,'dest_port')
		if (protocol == 'TCP' or protocol == 'UDP') and src_port == '':
			src_port = 'Anyport'
		if (protocol == 'TCP' or protocol == 'UDP') and dest_port == '':
			dest_port = 'Anyport'
		ext =''
		if target == 'SNAT':
			ext =  ' --> src: '+i['tgt_snat']['new_src_ip']
			if i['tgt_snat'].has_key('port_range') == 1:
				ext = ext+':'+i['tgt_snat']['port_range']
		if target == 'DNAT':
			ext =  ' --> dest: '+i['tgt_dnat']['new_dest_ip']
			if i['tgt_dnat'].has_key('port_range') == 1:
				ext = ext+':'+i['tgt_dnat']['port_range']
		if target == 'REDIRECT':
			ext =  ' --> '+i['tgt_redirect']['port_range']
		if target == 'MASQUERADE':
			ext =  ' --> '+i['tgt_masq']['port_range']
		c.append((('%s'%x),protocol,src_ip,dest_ip,src_port,dest_port,target,ext))
		x=x+1

def init_window(gdata):
	init_combo(gdata,'cmb_table1',gdata.tables)
	init_combo(gdata,'cmb_table2',gdata.tables)
	if DEBUG == 1: print 'Init Window'

def mnu_new_activate(self,gdata):
	if DEBUG == 1: print 'new clicked'
	gdata.new(gdata.wtree)
	add_rule_dialog.cancel(None,gdata)
	add_iface_dialog.btn_iface_cancel_clicked(None,gdata)
	add_port_dialog.btn_port_cancel_clicked(None,gdata)
	add_ip_dialog.btn_ip_cancel_clicked(None,gdata)
	init_window(gdata)

def mnu_save_as_activate(self,gdata):
	if DEBUG == 1: print 'save as clicked'
	gdata.fsel_mode = 'save_as'
	fs=gdata.wtree.get_widget('dlg_file_sel')
	fs.set_filename('')
	fs.show()

def mnu_load_activate(self,gdata):
	if DEBUG == 1: print 'save as clicked'
	gdata.fsel_mode = 'load'
	fs=gdata.wtree.get_widget('dlg_file_sel')
	fs.set_filename('')
	fs.show()

def mnu_create_script_activate(self,gdata):
	gdata.fsel_mode = 'script'
	fs=gdata.wtree.get_widget('dlg_file_sel')
	fs.set_filename('')
	fs.show()

def txt_table1_changed(self,gdata):
	table = gdata.wtree.get_widget('txt_table1').get_text()
	init_chain_combo(gdata,'cmb_chain1',gdata.chains[table],gdata.user[table])

def txt_table2_changed(self,gdata):
	table = gdata.wtree.get_widget('txt_table2').get_text()
	init_chain_combo(gdata,'cmb_chain2',gdata.chains[table],gdata.user[table])
	

def txt_chain1_changed(self,gdata):
	c = gdata.wtree.get_widget('cls_chain1')
	c.clear()
	table = gdata.wtree.get_widget('txt_table1').get_text()
	chain = gdata.wtree.get_widget('txt_chain1').get_text()
	show_rules(gdata,c,table,chain)

def txt_chain2_changed(self,gdata):
	c = gdata.wtree.get_widget('cls_chain2')
	c.clear()
	table = gdata.wtree.get_widget('txt_table2').get_text()
	chain = gdata.wtree.get_widget('txt_chain2').get_text()
	show_rules(gdata,c,table,chain)



def btn_add1_clicked(self,gdata):
	if gdata.dialog_vis==0:
		table = gdata.wtree.get_widget('txt_table1').get_text()
		chain = gdata.wtree.get_widget('txt_chain1').get_text()
		gdata.current_table = table
		gdata.current_chain = chain
		add_rule_dialog.show(gdata)

def btn_add2_clicked(self,gdata):
	if gdata.dialog_vis==0:
		table = gdata.wtree.get_widget('txt_table2').get_text()
		chain = gdata.wtree.get_widget('txt_chain2').get_text()
		gdata.current_table = table
		gdata.current_chain = chain
		add_rule_dialog.show(gdata)


def btn_del1_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain1')
		table = gdata.wtree.get_widget('txt_table1').get_text()
		chain = gdata.wtree.get_widget('txt_chain1').get_text()
		for i in c.selection:
			if DEBUG == 1: print "Selected rows:"
			row = string.atoi(c.get_text(i,0))
			gdata.del_rule(table,chain,row)
			if DEBUG == 1: print 'Deleting:',table,chain,row
			c.remove(i)
		txt_chain1_changed(None,gdata)
		txt_chain2_changed(None,gdata)

def btn_del2_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain2')
		table = gdata.wtree.get_widget('txt_table2').get_text()
		chain = gdata.wtree.get_widget('txt_chain2').get_text()
		for i in c.selection:
			if DEBUG == 1: print "Selected rows:"
			row = string.atoi(c.get_text(i,0))
			gdata.del_rule(table,chain,row)
			if DEBUG == 1: print 'Deleting:',table,chain,row
			c.remove(i)
		txt_chain1_changed(None,gdata)
		txt_chain2_changed(None,gdata)

def btn_edit1_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain1')
		table = gdata.wtree.get_widget('txt_table1').get_text()
		chain = gdata.wtree.get_widget('txt_chain1').get_text()
		gdata.current_table = table
		gdata.current_chain = chain
		rules = gdata.get_chain(table,chain)
		if len(c.selection) == 1:
			gdata.dlg_rule_mode='edit'
			rulenum = c.selection[0]
			rule = rules[rulenum]
			gdata.current_rulenum=rulenum
			edit_rule_dialog.show(gdata,rule,table,chain)
			if DEBUG == 1: print rule

def btn_edit2_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain2')
		table = gdata.wtree.get_widget('txt_table2').get_text()
		chain = gdata.wtree.get_widget('txt_chain2').get_text()
		gdata.current_table = table
		gdata.current_chain = chain
		rules = gdata.get_chain(table,chain)
		if len(c.selection) == 1:
			gdata.dlg_rule_mode='edit'
			rulenum = c.selection[0]
			rule = rules[rulenum]
			gdata.current_rulenum=rulenum
			edit_rule_dialog.show(gdata,rule,table,chain)
			if DEBUG == 1: print rule

def btn_up1_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain1')
		table = gdata.wtree.get_widget('txt_table1').get_text()
		chain = gdata.wtree.get_widget('txt_chain1').get_text()
		rules = gdata.get_chain(table,chain)
		if len(c.selection) == 1:
			rulenum = c.selection[0]
			gdata.move_rule_up(table,chain,rulenum)
			txt_chain1_changed(None,gdata)
			txt_chain2_changed(None,gdata)
			if rulenum != 0:
				c.select_row(rulenum-1,0)

def btn_up2_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain2')
		table = gdata.wtree.get_widget('txt_table2').get_text()
		chain = gdata.wtree.get_widget('txt_chain2').get_text()
		rules = gdata.get_chain(table,chain)
		if len(c.selection) == 1:
			rulenum = c.selection[0]
			gdata.move_rule_up(table,chain,rulenum)
			txt_chain1_changed(None,gdata)
			txt_chain2_changed(None,gdata)
			if rulenum != 0:
				c.select_row(rulenum-1,0)

def btn_down1_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain1')
		table = gdata.wtree.get_widget('txt_table1').get_text()
		chain = gdata.wtree.get_widget('txt_chain1').get_text()
		rules = gdata.get_chain(table,chain)
		if len(c.selection) == 1:
			rulenum = c.selection[0]
			gdata.move_rule_down(table,chain,rulenum)
			txt_chain1_changed(None,gdata)
			txt_chain2_changed(None,gdata)
			if rulenum < (len(rules)-1):
				c.select_row(rulenum+1,0)

def btn_down2_clicked(self,gdata):
	if gdata.dialog_vis == 0:
		c = gdata.wtree.get_widget('cls_chain2')
		table = gdata.wtree.get_widget('txt_table2').get_text()
		chain = gdata.wtree.get_widget('txt_chain2').get_text()
		rules = gdata.get_chain(table,chain)
		if len(c.selection) == 1:
			rulenum = c.selection[0]
			gdata.move_rule_down(table,chain,rulenum)
			txt_chain1_changed(None,gdata)
			txt_chain2_changed(None,gdata)
			if rulenum < (len(rules)-1):
				c.select_row(rulenum+1,0)

def mnu_add_interface_activate(self,gdata):
	add_iface_dialog.show(gdata)

def mnu_add_port_alias_activate(self,gdata):
	add_port_dialog.show(gdata)

def mnu_add_ip_activate(self,gdata):
	add_ip_dialog.show(gdata)

def window_resized(self,gdata):
	hlp = ''
