#/usr/bin/env python

import shelve
import sys
import string

#a = {}
#i = {}
#f = {}
#p = {}
#usr = {}



def listsearch(haystack,needle):
	for x in haystack:
		if x == needle:
			return 1
	return None


def is_ip_alias(data):
	if listsearch(i.keys(),data) == 1:
		return 1
	return None

def is_port_alias(data):
	if listsearch(p.keys(),data) == 1:
		return 1
	return None

def prot(data):
	if data['inv'] == 'TRUE':
		return ' ! -p '+data['name']
	else: return ' -p '+data['name']

def ip(data):
	hlp = ''
	if data.has_key('src_ip'):
		if data['src_ip']['inv'] == 'TRUE':
			if is_ip_alias(data['src_ip']['name']) == 1:
				hlp = ' ! -s $'+data['src_ip']['name']
			else:
				hlp = ' ! -s '+data['src_ip']['name']
		else:
			if is_ip_alias(data['src_ip']['name']) == 1:
				hlp = hlp + ' -s $'+data['src_ip']['name']
			else:
				hlp = hlp + ' -s '+data['src_ip']['name']
	if data.has_key('dest_ip'):
		if data['dest_ip']['inv']=='TRUE':
			if is_ip_alias(data['dest_ip']['name']) == 1:
				hlp = hlp + ' ! -d $'+data['dest_ip']['name']
			else:
				hlp = hlp + ' ! -d '+data['dest_ip']['name']
		else:
			if is_ip_alias(data['dest_ip']['name']) == 1:
				hlp = hlp + ' -d $'+data['dest_ip']['name']
			else:
				hlp = hlp + ' -d '+data['dest_ip']['name']
	return hlp

def iface(data):
	hlp = ''
	if data.has_key('in_iface'):
		if data['in_iface']['inv'] == 'TRUE':
			hlp = ' ! -i '+data['in_iface']['name']
		else:
			hlp = ' -i '+data['in_iface']['name']
	if data.has_key('out_iface'):
		if data['out_iface']['inv'] == 'TRUE':
			hlp = hlp + ' ! -o '+data['out_iface']['name']
		else:
			hlp = hlp + ' -o '+data['out_iface']['name']
	return hlp
def port(data):
	hlp = ''
	if data.has_key('src_port'):
		if data['src_port']['inv'] == 'TRUE':
			if is_port_alias(data['src_port']['name']) == 1:
				hlp = ' ! --sport $'+data['src_port']['name']
			else:
				hlp = ' ! --sport '+data['src_port']['name']
		else:
			if is_port_alias(data['src_port']['name']) == 1:
				hlp = hlp + ' --sport $'+data['src_port']['name']
			else:
				hlp = hlp + ' --sport '+data['src_port']['name']

	if data.has_key('dest_port'):
		if data['dest_port']['inv'] == 'TRUE':
			if is_port_alias(data['dest_port']['name']) == 1:
				hlp = hlp + ' ! --dport $'+data['dest_port']['name']
			else:
				hlp = hlp + ' ! --dport '+data['dest_port']['name']
		else:
			if is_port_alias(data['dest_port']['name']) == 1:
				hlp = hlp + ' --dport $'+data['dest_port']['name']
			else:
				hlp = hlp + ' --dport '+data['dest_port']['name']
	return hlp

def snat(data):
	hlp=''
	if data.has_key('tgt_snat'):
		if is_ip_alias(data['tgt_snat']['new_src_ip']) == 1:
			hlp = ' --to-source '+string.split(i[data['tgt_snat']['new_src_ip']]['address'],'/')[0]
		else:
			hlp = ' --to-source '+data['tgt_snat']['new_src_ip']
		if data['tgt_snat'].has_key('port_range') == 1:
			if is_port_alias(data['tgt_snat']['port_range']) == 1:
				pn = data['tgt_snat']['port_range']
				pr = p[pn]['begin']
				if p[pn]['end'] != None:
					pr = pr+'-'+p[pn]['end']
				hlp = hlp+':'+pr
			else:
				hlp = hlp+':'+data['tgt_snat']['port_range']
	return hlp

def dnat(data):
	hlp=''
	if data.has_key('tgt_dnat'):
		if is_ip_alias(data['tgt_dnat']['new_dest_ip']) == 1:
			hlp = ' --to-destination '+string.split(i[data['tgt_dnat']['new_dest_ip']]['address'],'/')[0]
		else:
			hlp = ' --to-destination '+data['tgt_dnat']['new_dest_ip']
		if data['tgt_dnat'].has_key('port_range') == 1:
			if is_port_alias(data['tgt_dnat']['port_range']) == 1:
				pn = data['tgt_dnat']['port_range']
				pr = p[pn]['begin']
				if p[pn]['end'] != None:
					pr = pr+'-'+p[pn]['end']
				hlp = hlp+':'+pr
			else:
				hlp = hlp+':'+data['tgt_dnat']['port_range']
	return hlp

def generate(dataarray,datafile,scriptfile):
	#if no dataarray => None
	#if no datafile => None
	o = [] #List where script will be stored
	if datafile != None and dataarray ==None:
		d = shelve.open(datafile)
	if dataarray != None and datafile == None:
		d = dataarray
	if dataarray == None and datafile == None:
		raise 'Scriptgen.py: No data source specified!'
	global a
	a = d['rules']
	global i
	i = d['ip']
	global f
	f = d['iface']
	global p
	p = d['port']
	usr = d['user']
	if datafile != None: d.close()
	#--reset iptables------
	o.append('#!/bin/sh')
	o.append('#prepare iptables')
	o.append('iptables -X')
	o.append('iptables -F')
	o.append('iptables -Z')
	o.append('iptables -X -t nat')
	o.append('iptables -F -t nat')
	o.append('iptables -Z -t nat')
	o.append('iptables -X -t mangle')
	o.append('iptables -F -t mangle')
	o.append('iptables -Z -t mangle')
	o.append('#-------------------\n')
	#--create user chains--
	o.append('#insert user chains')
	for usr_t in usr.keys():
		for usr_x in usr[usr_t]:
			o.append('iptables -N '+usr_x+' -t '+usr_t)
	o.append('#-------------------\n')
	#generate aliases
	#--ip--
	o.append('#insert ip aliases')
	for ip_x in i.keys():
		o.append(ip_x+'='+i[ip_x]['address']+'\t# '+i[ip_x]['comment'])
	o.append('#-------------------\n')
	#--port--
        o.append('#insert port aliases')
	for port_x in p.keys():
		if p[port_x]['end'] != None:
			o.append(port_x+'='+p[port_x]['begin']+':'+p[port_x]['end']+'\t# '+p[port_x]['comment'])
		else:
			o.append(port_x+'='+p[port_x]['begin']+'\t# '+p[port_x]['comment'])
	o.append('#-------------------\n')
	#generate rules
	for x in a.keys():
		o.append('### '+x+' table\n')
		for y in a[x].keys():
			o.append('#--- '+y+' chain')
			for z in a[x][y]:
				#print '----------------'
 				#print z['prot']
				#print '----------------'
				if x == 'filter':
					r = 'iptables -A '+y+prot(z['prot'])
				else:
					r = 'iptables -A '+y+' -t '+x+prot(z['prot'])
				r = r+ip(z)
				r = r+iface(z)
				r = r+port(z)
				#----------------------------------------------------------------
				if z['fragment']['enabled'] == 'TRUE':
					if z['fragment']['inv'] == 'TRUE':
						r = r+' ! --fragment '
					else:
						r = r+' --fragment '

				if p == 'TCP ':
					print '---TCP---'
					if z.has_key('tcp_flags') == 1:
						if z['tcp_flags']['inv'] == 'TRUE':
							r = r+' ! --tcp-flags '+z['tcp_flags']['mask']+' '+z['tcp_flags']['comp']
						else:
							r = r+' --tcp-flags '+z['tcp_flags']['mask']+' '+z['tcp_flags']['comp']
					if z.has_key('syn') == 1:
						if z['syn']['inv'] == 'TRUE':
							r = r+' ! --syn'
						else:
							r = r+' --syn'
					if z.has_key('tcp_option') == 1:
						if z['tcp_option']['inv'] == 'TRUE':
							r = r+' ! --tcp-option '+z['tcp_option']['value']
						else:
							r = r+' --tcp-option '+z['tcp_option']['value']
				if p == 'ICMP ':
					print '---ICMP---'
					if z.has_key('icmp_type') == 1:
						if z['icmp_type']['inv'] == 'TRUE':
							r = r+' ! --icmp_type'+z['icmp_type']['value']
				#----------------------------------------------------------------
				if z['limit']['enabled']=='TRUE':
					r = r+' -m limit --limit '+z['limit']['rate']+z['limit']['rate_suffix']+' --limit-burst '+z['limit']['burst']
				if z['mark']['enabled'] =='TRUE':
					r = r+' -m mark --mark '+z['mark']['value']
				if z['state']['enabled'] =='TRUE':
					r = r+' -m state --state '+z['state']['value']
				if z['tos']['enabled'] =='TRUE':
					r = r+' -m tos --tos '+z['tos']['value']
				#----------------------------------------------------------------
				r=r+' -j '+z['target']
				if z.has_key('tgt_log') == 1:
					hlp = ''
					if z['tgt_log'].has_key('level') == 1:
						hlp = ' --log-level '+z['tgt_log']['level']
					if z['tgt_log'].has_key('prefix') == 1:
						hlp = hlp+' --log-prefix '+z['tgt_log']['prefix']
					if z['tgt_log']['tcp_sequence'] == 'TRUE':
						hlp = hlp+' --log-tcp-sequence'
					if z['tgt_log']['tcp_options'] == 'TRUE':
						hlp = hlp+' --log-tcp-options'
					if z['tgt_log']['ip_options'] == 'TRUE':
						hlp = hlp+' --log-ip-options'
					r = r+hlp
				if z.has_key('tgt_mark') == 1:
					r = r+' --set-mark '+z['tgt_mark']['value']
				if z.has_key('tgt_reject') == 1:
					r = r+' --reject-with '+z['tgt_reject']['reject_type']
				if z.has_key('tgt_tos') == 1:
					r = r+' --set-tos '+z['tgt_tos']['value']
				r = r+snat(z)
				r = r+dnat(z)
				if z.has_key('tgt_masq') == 1:
					if is_port_alias(z['tgt_masq']['port_range']) == 1:
						pn = z['tgt_masq']['port_range']
						if p[pn]['end'] != None:
							pr = ' --to-ports '+p[pn]['begin']
							r = pr+'-'+p[pn]['end']
						else:
							r = r+' --to-ports $'+z['tgt_masq']['port_range']
					else:
						r = r+' --to-ports '+z['tgt_masq']['port_range']

				if z.has_key('tgt_redirect') == 1:
					if is_port_alias(z['tgt_redirect']['port_range']) == 1:
						pn = z['tgt_redirect']['port_range']
						if p[pn]['end'] != None:
							pr = ' --to-ports '+p[pn]['begin']
							r = pr+'-'+p[pn]['end']
						else:
							r = r+' --to-ports $'+z['tgt_redirect']['port_range']
					else:
						r = r+' --to-ports '+z['tgt_redirect']['port_range']
				#o.append('echo \''+r+'\'')
				o.append(r)

			o.append('#-------------------\n')
		o.append('###-----------------\n')
	#for oi in o:
		#print oi
	script = open(scriptfile,'w')
	for line in o:
		script.write(line+'\n')
	script.close()
#generate('None','scripttest.data','fw_script.sh')
